<?php
/*  Copyright 2008  Ryan Christenson - The RSWR Network (ryan@rswr.net - www.rswr.net)
    
    Plugin Name: 	diggZ-Et
    Plugin URI: 	http://blog.rswr.net/2008/05/23/wordpress-plugin-diggz-et/
    Description: 	Automatically displays a "digg" button for each post. Aditional settings available.
    Version: 		1.0
    Author: 		Ryan Christenson (The RSWR Network)
    Author URI: 	http://www.rswr.net/


    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (!class_exists("diggZEt")) {
	class diggZEt {
		var $adminOptionsName = "diggZEtAdminOptions";
		function diggZEt() { //constructor
		}

		//Returns an array of admin options
		function getAdminOptions() {
			$dZEtAdminOptions = array('home' => 'true', 'post' => 'true', 'bg' => 'true', 'skin' => 'true', 'win' => 'true', 'media' => 'true', 'topic' => 'true');
			$dZEtOptions = get_option($this->adminOptionsName);
			if (!empty($dZEtOptions)) {
				foreach ($dZEtOptions as $key => $option)
				$dZEtAdminOptions[$key] = $option;
			}
			update_option($this->adminOptionsName, $dZEtAdminOptions);
			return $dZEtAdminOptions;
		}
		function init() {
			$this->getAdminOptions();
		}

		//Prints out the admin page
		function printAdminPage() {
			$dZEtOptions = $this->getAdminOptions();
			if (isset($_POST['update_diggZEtSettings'])) {
			
				// Save Settings
				if($_POST['home'] == "on") update_option('dZEt_home', "checked=on");
  				else update_option('dZEt_home', "");
  				if($_POST['post'] == "on") update_option('dZEt_post', "checked=on");
  				else update_option('dZEt_post', "");
  				$bg = $_POST['bg'];
  				$skin = $_POST['skin'];
  				$win = $_POST['win'];
  				$media = $_POST['media'];
  				$topic = $_POST['topic'];

				// Update Settings
				update_option('dZEt_bg', $bg);
				update_option('dZEt_skin', $skin);
				update_option('dZEt_win', $win);
				update_option('dZEt_media', $media);
				update_option('dZEt_topic', $topic);

				// Update Admin
				update_option($this->adminOptionsName, $dZEtOptions);
?>
<div class="updated"><p><strong><?php _e("Options Updated!", "diggZEt");?></strong></p></div>
<?php
			} else {
				// Retrieve Options
				$bg = get_option('dZEt_bg');
				$skin = get_option('dZEt_skin');
				$win = get_option('dZEt_win');
				$media = get_option('dZEt_media');
				$topic = get_option('dZEt_topic');
			}
?>
<div class=wrap>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<h2>diggZ-Et Options</h2>
<h3>Show/Hide Options</h3>
<input type="checkbox" name="home" <?php echo get_option('dZEt_home'); ?> /> Hide Buttons on Home Page (Recommended to speed up your Home Page's load time.)
<br /><input type="checkbox" name="post" <?php echo get_option('dZEt_post'); ?> /> Hide Buttons on Individual Posts (Not Recommended)
<h3>Digg Button Options</h3>
<strong>Background Color</strong> - <span style="color:red;">Must be in Hex Format</span><br />
<input type="text" name="bg" size="10" maxlength="7" value="<?php if ($bg == "") {echo "#FFFFFF";} else {echo $bg;} ?>" />
<br /><br />
<strong>Skin Type</strong><br />
<select id="skin" name="skin">
	<option value="" <?php echo $skin=="" ? "selected" : ""; ?>>Default</option>
	<option value="compact" <?php echo $skin=="compact" ? "selected" : ""; ?>>Compact</option>
	<option value="icon" <?php echo $skin=="icon" ? "selected" : ""; ?>>Icon</option>
</select>
<br /><br />
<strong>Browser Window</strong><br />
<select id="win" name="win">
	<option value="" <?php echo $win=="" ? "selected" : ""; ?>>Default Window</option>
	<option value="new" <?php echo $win=="new" ? "selected" : ""; ?>>New Window</option>
</select>
<br /><br />
<strong>Media</strong> - <span style="color:red;">The type of media being submitted</span><br />
<select id="media" name="media">
	<option value="news" <?php echo $media=="news" ? "selected" : ""; ?>>News</option>
	<option value="video" <?php echo $media=="video" ? "selected" : ""; ?>>Video</option>
	<option value="image" <?php echo $media=="image" ? "selected" : ""; ?>>Image</option>
</select>
<br /><br />
<strong>Topic</strong> - <span style="color:red;">Leave this set to "Blank" if you want the poster to decide on the topic.</span><br />
<select id="topic" name="topic">
	<option value="" <?php echo $topic=="" ? "selected" : ""; ?>>Blank</option>
	<option value="2008_us_elections" <?php echo $topic=="2008_us_elections" ? "selected" : ""; ?>>2008 US Elections</option>
	<option value="apple" <?php echo $topic=="apple" ? "selected" : ""; ?>>Apple</option>
	<option value="arts_culture" <?php echo $topic=="arts_culture" ? "selected" : ""; ?>>Arts Culture</option>
	<option value="autos" <?php echo $topic=="autos" ? "selected" : ""; ?>>Autos</option>
	<option value="baseball" <?php echo $topic=="baseball" ? "selected" : ""; ?>>Baseball</option>
	<option value="basketball" <?php echo $topic=="basketball" ? "selected" : ""; ?>>Basketball</option>
	<option value="business_finance" <?php echo $topic=="business_finance" ? "selected" : ""; ?>>Business Finance</option>
	<option value="celebrity" <?php echo $topic=="celebrity" ? "selected" : ""; ?>>Celebrity</option>
	<option value="comedy" <?php echo $topic=="comedy" ? "selected" : ""; ?>>Comedy</option>
	<option value="comics_animation" <?php echo $topic=="comics_animation" ? "selected" : ""; ?>>Comics Animation</option>
	<option value="design" <?php echo $topic=="design" ? "selected" : ""; ?>>Design</option>
	<option value="educational" <?php echo $topic=="educational" ? "selected" : ""; ?>>Educational</option>
	<option value="environment" <?php echo $topic=="environment" ? "selected" : ""; ?>>Environment</option>
	<option value="extreme_sports" <?php echo $topic=="extreme_sports" ? "selected" : ""; ?>>Extreme Sports</option>
	<option value="food_drink" <?php echo $topic=="food_drink" ? "selected" : ""; ?>>Food Drink</option>
	<option value="football" <?php echo $topic=="football" ? "selected" : ""; ?>>Football</option>
	<option value="gadgets" <?php echo $topic=="gadgets" ? "selected" : ""; ?>>Gadgets</option>
	<option value="gaming_news" <?php echo $topic=="gaming_news" ? "selected" : ""; ?>>Gaming News</option>
	<option value="general_sciences" <?php echo $topic=="general_sciences" ? "selected" : ""; ?>>General Sciences</option>
	<option value="golf" <?php echo $topic=="golf" ? "selected" : ""; ?>>Golf</option>
	<option value="hardware" <?php echo $topic=="hardware" ? "selected" : ""; ?>>Hardware</option>
	<option value="health" <?php echo $topic=="health" ? "selected" : ""; ?>>Health</option>
	<option value="hockey" <?php echo $topic=="hockey" ? "selected" : ""; ?>>Hockey</option>
	<option value="linux_unix" <?php echo $topic=="linux_unix" ? "selected" : ""; ?>>Linux Unix</option>
	<option value="microsoft" <?php echo $topic=="microsoft" ? "selected" : ""; ?>>Microsoft</option>
	<option value="mods" <?php echo $topic=="mods" ? "selected" : ""; ?>>Mods</option>
	<option value="motorsport" <?php echo $topic=="motorsport" ? "selected" : ""; ?>>Motorsport</option>
	<option value="movies" <?php echo $topic=="movies" ? "selected" : ""; ?>>Movies</option>
	<option value="music" <?php echo $topic=="music" ? "selected" : ""; ?>>Music</option>
	<option value="nintendo" <?php echo $topic=="nintendo" ? "selected" : ""; ?>>Nintendo</option>
	<option value="odd_stuff" <?php echo $topic=="odd_stuff" ? "selected" : ""; ?>>Odd Stuff</option>
	<option value="other_sports" <?php echo $topic=="other_sports" ? "selected" : ""; ?>>Other Sports</option>
	<option value="pc_games" <?php echo $topic=="pc_games" ? "selected" : ""; ?>>PC Games</option>
	<option value="people" <?php echo $topic=="people" ? "selected" : ""; ?>>People</option>
	<option value="pets_animals" <?php echo $topic=="pets_animals" ? "selected" : ""; ?>>Pets Animals</option>
	<option value="playable_web_games" <?php echo $topic=="playable_web_games" ? "selected" : ""; ?>>Playable Web Games</option>
	<option value="playstation" <?php echo $topic=="playstation" ? "selected" : ""; ?>>Playstation</option>
	<option value="political_opinion" <?php echo $topic=="political_opinion" ? "selected" : ""; ?>>Political Opinion</option>
	<option value="politics" <?php echo $topic=="politics" ? "selected" : ""; ?>>Politics</option>
	<option value="programming" <?php echo $topic=="programming" ? "selected" : ""; ?>>Programming</option>
	<option value="security" <?php echo $topic=="security" ? "selected" : ""; ?>>Security</option>
	<option value="soccer" <?php echo $topic=="soccer" ? "selected" : ""; ?>>Soccer</option>
	<option value="software" <?php echo $topic=="software" ? "selected" : ""; ?>>Software</option>
	<option value="space" <?php echo $topic=="space" ? "selected" : ""; ?>>Space</option>
	<option value="tech_news" <?php echo $topic=="tech_news" ? "selected" : ""; ?>>Tech News</option>
	<option value="television" <?php echo $topic=="television" ? "selected" : ""; ?>>Television</option>
	<option value="tennis" <?php echo $topic=="tennis" ? "selected" : ""; ?>>Tennis</option>
	<option value="travel_places" <?php echo $topic=="travel_places" ? "selected" : ""; ?>>Travel Places</option>
	<option value="world_news" <?php echo $topic=="world_news" ? "selected" : ""; ?>>World News</option>
	<option value="xbox" <?php echo $topic=="xbox" ? "selected" : ""; ?>>Xbox</option>
</select>

	<div class="submit">
		<input type="submit" name="update_diggZEtSettings" value="<?php _e('Update Settings', 'diggZEt') ?>" />
	</div>
</form>
</div>
<?php
		}
	}
}

//Initialize the admin panel
if (!function_exists("diggZEt_ap")) {
	function diggZEt_ap() {
		global $dl_pluginSeries;
		if (!isset($dl_pluginSeries)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('diggZ-Et', 'diggZ-Et', 9,
			basename(__FILE__), array(&$dl_pluginSeries, 'printAdminPage'));
		}
	}
}

if (!function_exists("diggZEt_But")) {

function diggZEt_But($content) {

if(is_home() && get_option('dZEt_home') == "checked=on") return $content;
if(is_single() && get_option('dZEt_post') == "checked=on") return $content;

				// Styling
				echo '<div class="diggthisplugin" style="float: right; width: 42px; padding-right: 10px; margin-left: 10px; margin-bottom: 0px;">';
				// Retrieve Options
				$bg = get_option('dZEt_bg');
				$skin = get_option('dZEt_skin');
				$win = get_option('dZEt_win');
				$media = get_option('dZEt_media');
				$topic = get_option('dZEt_topic');
		?>
<div>
<script type="text/javascript">
digg_url = '<?php urlencode(the_permalink()); ?>';
digg_bgcolor = '<?php echo $bg; ?>';
digg_skin = '<?php echo $skin; ?>';
digg_window = '<?php echo $win; ?>';
digg_title = '<?php urlencode(the_title()); ?>';
digg_media = '<?php echo $media; ?>';
digg_topic = '<?php echo $topic; ?>';
</script>
<script src="http://digg.com/tools/diggthis.js" type="text/javascript"></script>
</div>
		<?php
		echo '</div>' . $content;
}
}

// Initialize Class
if (class_exists("diggZEt")) {
	$dl_pluginSeries = new diggZEt();
}

//Actions and Filters
if (isset($dl_pluginSeries)) {
	//Actions
	add_action('diggZ-Et/diggZ-Et.php', array(&$dl_pluginSeries, 'init'));
	add_action('admin_menu', 'diggZEt_ap');
	//Filters
	add_filter('the_content', 'diggZEt_But');
}

?>
